#
# spec file for package cram
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%{?!python_module:%define python_module() python-%{**} python3-%{**}}
Name:           cram
Version:        0.7
Release:        bp153.1.15
Summary:        A simple testing framework for command line applications
License:        GPL-2.0
Group:          Development/Languages/Python
Url:            https://bitheap.org/cram/
Source:         https://bitheap.org/cram/cram-%{version}.tar.gz
BuildRequires:  %{python_module base}
BuildRequires:  %{python_module coverage}
BuildRequires:  %{python_module devel}
BuildRequires:  %{python_module nose}
BuildRequires:  %{python_module pep8}
BuildRequires:  %{python_module pyflakes}
BuildRequires:  %{python_module setuptools}
BuildRequires:  fdupes
BuildRequires:  python-rpm-macros
Requires:       python-coverage
Requires:       python-nose
Requires:       python-pep8
Requires:       python-pyflakes
Requires(post): update-alternatives
Requires(postun): update-alternatives
BuildArch:      noarch
%ifpython3
Provides:       cram = %{version}
Obsoletes:      cram < %{version}
%endif
%python_subpackages

%description
Cram is a functional testing framework for command line applications
based on Mercurial's `unified test format'.

Cram tests look like snippets of interactive shell sessions. Cram runs
each command and compares the command output in the test with the
command's actual output.

%package -n %{name}-common
Summary:        Common files for %{name}
Group:          Development/Languages/Python
Supplements:    python2-%{name}
Supplements:    python3-%{name}

%description -n %{name}-common
Cram is a functional testing framework for command line applications
based on Mercurial's `unified test format'.

Cram tests look like snippets of interactive shell sessions. Cram runs
each command and compares the command output in the test with the
command's actual output.

This package contains common files for %{name}.

%prep
%setup -q

%build
%python_build

%install
%python_install
%python_clone -a %{buildroot}%{_bindir}/cram
%fdupes %{buildroot}
install -D -p -m 0644 contrib/cram.vim \
  %{buildroot}%{_datadir}/vim/site/syntax/cram.vim

%post
%python_install_alternative cram

%postun
%python_uninstall_alternative cram

%check
make %{?_smp_mflags} PYTHON=python2 test
make %{?_smp_mflags} PYTHON=python3 test

%files %{python_files}
%defattr(-,root,root,-)
%doc COPYING.txt NEWS.rst README.rst
%python_alternative %{_bindir}/cram
%{python_sitelib}/*

%files -n %{name}-common
%defattr(-,root,root)
%dir %{_datadir}/vim
%dir %{_datadir}/vim/site
%dir %{_datadir}/vim/site/syntax
%{_datadir}/vim/site/syntax/cram.vim

%changelog
* Mon Jul 10 2017 toddrme2178@gmail.com
- Add singlespec macro backwards compatibility shims.
* Tue Jun 27 2017 mpluskal@suse.com
- Provide/obsolete old cram
* Wed Jun 14 2017 mpluskal@suse.com
- Convert to singlespec
* Sun Sep 25 2016 mpluskal@suse.com
- Use upstream download url instead of pypi
- Install vim syntax plugin
- Finally correct dependencies
- Drop SLE conditions
* Mon Aug 22 2016 mpluskal@suse.com
- Disable tests and its dependencies for SLE
* Fri Jun 17 2016 mpluskal@suse.com
- Update testsuite dependencies and enable all tests
* Thu Apr 28 2016 mimi.vx@gmail.com
- update to 0.7
  * Added the -d/--debug flag that disables diffing of expected/actual output and
    instead passes through script output to stdout/stderr.
  * Added the --shell-opts flag for specifying flags to invoke the shell with. By
    setting --shell-opts='-x' and --debug together, this can be used to see shell
    commands as they're run and their output in real time which can be useful for
    debugging slow or hanging tests.
  * Added xUnit XML output support (for better integration of test results with Bamboo
    and other continuous integration tools).
  * Added support for using (esc) on expected out lines that aren't automatically
    escaped in actual output.
  * Added the $TESTSHELL environment variable. This allows a test to portably check
    what shell it was invoked with.
  * Added an error message for when no tests are found in a directory.
  * Changed Makefile to install into /usr/local by default.
  * Simplified the Makefile's targets. The targets available now are all, build,
    check/test, clean, dist, install, and quicktest (for running the test suite
    without checking test coverage).
  * Fixed non-ASCII strings not being escaped with (esc) on Python 3.
  * Fixed a crash on tests that don't have a trailing newline.
  * Fixed a crash when using set -x with zsh.
* Sat Feb 20 2016 mpluskal@suse.com
- Switch to python3
- Minor spec file cleanups
* Fri Sep 18 2015 jmatejka@suse.cz
- Initial package ready for submission to Fatory. Version 0.6
